Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/SearchLogic.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/SearchLogic.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/SearchLogic.cs	(revision 13508)
@@ -0,0 +1,161 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+
+namespace HeuristicLab.DataPreprocessing {
+  public class SearchLogic {
+    private readonly ITransactionalPreprocessingData preprocessingData;
+    private readonly FilterLogic filterLogic;
+
+    private Dictionary<int, IList<int>> MissingValueIndicies { get; set; }
+    private Dictionary<int, IList> ValuesWithoutNaN { get; set; }
+
+    public IEnumerable<string> VariableNames {
+      get { return preprocessingData.VariableNames; }
+    }
+
+    public int Columns {
+      get { return preprocessingData.Columns; }
+    }
+
+    public int Rows {
+      get { return preprocessingData.Rows; }
+    }
+
+    public SearchLogic(ITransactionalPreprocessingData thePreprocessingData, FilterLogic theFilterLogic) {
+      preprocessingData = thePreprocessingData;
+      filterLogic = theFilterLogic;
+
+      MissingValueIndicies = new Dictionary<int, IList<int>>();
+      ValuesWithoutNaN = new Dictionary<int, IList>();
+
+      preprocessingData.Changed += PreprocessingData_Changed;
+      filterLogic.FilterChanged += FilterLogic_FilterChanged;
+    }
+
+    void FilterLogic_FilterChanged(object sender, EventArgs e) {
+      //recalculate
+      for (int i = 0; i < Columns; i++) {
+        MissingValueIndicies.Remove(i);
+        ValuesWithoutNaN.Remove(i);
+      }
+    }
+
+    void PreprocessingData_Changed(object sender, DataPreprocessingChangedEventArgs e) {
+      switch (e.Type) {
+        case DataPreprocessingChangedEventType.DeleteColumn:
+        case DataPreprocessingChangedEventType.ChangeColumn:
+          MissingValueIndicies.Remove(e.Column);
+          ValuesWithoutNaN.Remove(e.Column);
+          break;
+        case DataPreprocessingChangedEventType.AddColumn:
+          //cache does not need to be updated, will be calculated the first time it is requested
+          break;
+        case DataPreprocessingChangedEventType.DeleteRow:
+        case DataPreprocessingChangedEventType.AddRow:
+        case DataPreprocessingChangedEventType.ChangeItem:
+        case DataPreprocessingChangedEventType.Any:
+        case DataPreprocessingChangedEventType.Transformation:
+        default:
+          MissingValueIndicies = new Dictionary<int, IList<int>>();
+          ValuesWithoutNaN = new Dictionary<int, IList>();
+          break;
+      }
+    }
+
+    public IDictionary<int, IList<int>> GetMissingValueIndices() {
+      var dic = new Dictionary<int, IList<int>>();
+      for (int i = 0; i < preprocessingData.Columns; ++i) {
+        dic.Add(i, GetMissingValueIndices(i));
+      }
+      return dic;
+    }
+
+    public bool IsMissingValue(int columnIndex, int rowIndex) {
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        return double.IsNaN(preprocessingData.GetCell<double>(columnIndex, rowIndex));
+      } else if (preprocessingData.VariableHasType<string>(columnIndex)) {
+        return string.IsNullOrEmpty(preprocessingData.GetCell<string>(columnIndex, rowIndex));
+      } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        return preprocessingData.GetCell<DateTime>(columnIndex, rowIndex).Equals(DateTime.MinValue);
+      } else {
+        throw new ArgumentException("cell in column " + columnIndex + " and row index " + rowIndex + " contains a non supported type.");
+      }
+    }
+
+    public IList<int> GetMissingValueIndices(int columnIndex) {
+      if (!MissingValueIndicies.ContainsKey(columnIndex)) {
+        if (preprocessingData.VariableHasType<double>(columnIndex)) {
+          MissingValueIndicies[columnIndex] = GetMissingValueIndices<double>(columnIndex);
+        } else if (preprocessingData.VariableHasType<string>(columnIndex)) {
+          MissingValueIndicies[columnIndex] = GetMissingValueIndices<string>(columnIndex);
+        } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+          MissingValueIndicies[columnIndex] = GetMissingValueIndices<DateTime>(columnIndex);
+        } else {
+          throw new ArgumentException("column " + columnIndex + " contains a non supported type.");
+        }
+      }
+      return MissingValueIndicies[columnIndex];
+    }
+
+    private IList<int> GetMissingValueIndices<T>(int columnIndex) {
+      List<int> missingIndices = new List<int>();
+
+      for (int row = 0; row < preprocessingData.Rows; ++row) {
+        if (IsMissingValue(columnIndex, row)) {
+          missingIndices.Add(row);
+        }
+      }
+
+      return missingIndices;
+    }
+
+    public IEnumerable<T> GetValuesWithoutNaN<T>(int columnIndex, bool considerSelection) {
+      if (considerSelection) {
+        var selectedRows = preprocessingData.Selection[columnIndex];
+
+        List<T> values = new List<T>();
+        foreach (var rowIdx in selectedRows) {
+          if (!IsMissingValue(columnIndex, rowIdx)) {
+            values.Add(preprocessingData.GetCell<T>(columnIndex, rowIdx));
+          }
+        }
+        return values;
+      } else {
+        if (!ValuesWithoutNaN.ContainsKey(columnIndex)) {
+          List<T> values = new List<T>();
+
+          for (int row = 0; row < preprocessingData.Rows; ++row) {
+            if (!IsMissingValue(columnIndex, row)) {
+              values.Add(preprocessingData.GetCell<T>(columnIndex, row));
+            }
+          }
+
+          ValuesWithoutNaN[columnIndex] = values;
+        }
+        return (IEnumerable<T>)ValuesWithoutNaN[columnIndex];
+      }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/StatisticsLogic.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/StatisticsLogic.cs	(revision 13508)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/Logic/StatisticsLogic.cs	(revision 13508)
@@ -0,0 +1,235 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.DataPreprocessing {
+  public class StatisticsLogic {
+
+    private readonly ITransactionalPreprocessingData preprocessingData;
+    private readonly SearchLogic searchLogic;
+
+    public StatisticsLogic(ITransactionalPreprocessingData thePreprocessingData, SearchLogic theSearchLogic) {
+      preprocessingData = thePreprocessingData;
+      searchLogic = theSearchLogic;
+    }
+
+    public int GetColumnCount() {
+      return searchLogic.Columns;
+    }
+
+    public int GetRowCount() {
+      return searchLogic.Rows;
+    }
+
+    public int GetNumericColumnCount() {
+      int count = 0;
+
+      for (int i = 0; i < searchLogic.Columns; ++i) {
+        if (preprocessingData.VariableHasType<double>(i)) {
+          ++count;
+        }
+      }
+      return count;
+    }
+
+    public int GetNominalColumnCount() {
+      return searchLogic.Columns - GetNumericColumnCount();
+    }
+
+    public int GetMissingValueCount() {
+      int count = 0;
+      for (int i = 0; i < searchLogic.Columns; ++i) {
+        count += GetMissingValueCount(i);
+      }
+      return count;
+    }
+
+    public int GetMissingValueCount(int columnIndex) {
+      return searchLogic.GetMissingValueIndices(columnIndex).Count();
+    }
+
+    public T GetMin<T>(int columnIndex, bool considerSelection = false) where T : IComparable<T> {
+      var min = default(T);
+      if (preprocessingData.VariableHasType<T>(columnIndex)) {
+        var values = GetValuesWithoutNaN<T>(columnIndex, considerSelection);
+        if (values.Any()) {
+          min = values.Min();
+        }
+      }
+      return min;
+    }
+
+    public T GetMax<T>(int columnIndex, bool considerSelection = false) where T : IComparable<T> {
+      var max = default(T);
+      if (preprocessingData.VariableHasType<T>(columnIndex)) {
+        var values = GetValuesWithoutNaN<T>(columnIndex, considerSelection);
+        if (values.Any()) {
+          max = values.Max();
+        }
+      }
+      return max;
+    }
+
+    public double GetMedian(int columnIndex, bool considerSelection = false) {
+      double median = double.NaN;
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        var values = GetValuesWithoutNaN<double>(columnIndex, considerSelection);
+        if (values.Any()) {
+          median = values.Median();
+        }
+      }
+      return median;
+    }
+
+    public double GetAverage(int columnIndex, bool considerSelection = false) {
+      double avg = double.NaN;
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        var values = GetValuesWithoutNaN<double>(columnIndex, considerSelection);
+        if (values.Any()) {
+          avg = values.Average();
+        }
+      }
+      return avg;
+    }
+
+    public DateTime GetMedianDateTime(int columnIndex, bool considerSelection = false) {
+      DateTime median = new DateTime();
+      if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        median = GetSecondsAsDateTime(GetDateTimeAsSeconds(columnIndex, considerSelection).Median());
+      }
+      return median;
+    }
+
+    public DateTime GetAverageDateTime(int columnIndex, bool considerSelection = false) {
+      DateTime avg = new DateTime();
+      if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        avg = GetSecondsAsDateTime(GetDateTimeAsSeconds(columnIndex, considerSelection).Average());
+      }
+      return avg;
+    }
+
+    public T GetMostCommonValue<T>(int columnIndex, bool considerSelection = false) {
+      var values = GetValuesWithoutNaN<T>(columnIndex, considerSelection);
+      if (!values.Any())
+        return default(T);
+      return values.GroupBy(x => x)
+                              .OrderByDescending(g => g.Count())
+                              .Select(g => g.Key)
+                              .First();
+    }
+
+
+    public double GetStandardDeviation(int columnIndex) {
+      double stdDev = double.NaN;
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        stdDev = GetValuesWithoutNaN<double>(columnIndex).StandardDeviation();
+      } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        stdDev = GetDateTimeAsSeconds(columnIndex).StandardDeviation();
+      }
+      return stdDev;
+    }
+
+    public double GetVariance(int columnIndex) {
+      double variance = double.NaN;
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        variance = GetValuesWithoutNaN<double>(columnIndex).Variance();
+      } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        variance = GetDateTimeAsSeconds(columnIndex).Variance();
+      }
+      return variance;
+    }
+
+    public double GetOneQuarterPercentile(int columnIndex) {
+      double percentile = double.NaN;
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        percentile = GetValuesWithoutNaN<double>(columnIndex).Quantile(0.25);
+      } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        percentile = GetDateTimeAsSeconds(columnIndex).Quantile(0.25);
+      }
+      return percentile;
+    }
+
+    public double GetThreeQuarterPercentile(int columnIndex) {
+      double percentile = double.NaN;
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        percentile = GetValuesWithoutNaN<double>(columnIndex).Quantile(0.75);
+      } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        percentile = GetDateTimeAsSeconds(columnIndex).Quantile(0.75);
+      }
+      return percentile;
+    }
+
+    public int GetDifferentValuesCount<T>(int columnIndex) {
+      return preprocessingData.GetValues<T>(columnIndex).GroupBy(x => x).Count();
+    }
+
+    public int GetRowMissingValueCount(int rowIndex) {
+      int count = 0;
+      for (int i = 0; i < preprocessingData.Columns; ++i) {
+        if (searchLogic.IsMissingValue(i, rowIndex)) {
+          ++count;
+        }
+      }
+      return count;
+    }
+
+    public string GetVariableName(int columnIndex) {
+      return preprocessingData.GetVariableName(columnIndex);
+    }
+
+    public bool VariableHasType<T>(int columnIndex) {
+      return preprocessingData.VariableHasType<T>(columnIndex);
+    }
+
+    public string GetColumnTypeAsString(int columnIndex) {
+      if (preprocessingData.VariableHasType<double>(columnIndex)) {
+        return "double";
+      } else if (preprocessingData.VariableHasType<string>(columnIndex)) {
+        return "string";
+      } else if (preprocessingData.VariableHasType<DateTime>(columnIndex)) {
+        return "DateTime";
+      }
+      return "Unknown Type";
+    }
+
+    private IEnumerable<double> GetDateTimeAsSeconds(int columnIndex, bool considerSelection = false) {
+      return GetValuesWithoutNaN<DateTime>(columnIndex, considerSelection).Select(x => (double)x.Ticks / TimeSpan.TicksPerSecond);
+    }
+
+    private IEnumerable<T> GetValuesWithoutNaN<T>(int columnIndex, bool considerSelection = false) {
+      return searchLogic.GetValuesWithoutNaN<T>(columnIndex, considerSelection);
+    }
+
+    private DateTime GetSecondsAsDateTime(double seconds) {
+      DateTime dateTime = new DateTime();
+      return dateTime.AddSeconds(seconds);
+    }
+
+    public event DataPreprocessingChangedEventHandler Changed {
+      add { preprocessingData.Changed += value; }
+      remove { preprocessingData.Changed -= value; }
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/PreprocessingContext.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/PreprocessingContext.cs	(revision 13507)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/PreprocessingContext.cs	(revision 13508)
@@ -35,25 +35,4 @@
     public string Filename { get; set; }
 
-    public IEnumerable<KeyValuePair<string, Func<IItem>>> ExportPossibilities {
-      get {
-        var algorithm = Source as IAlgorithm;
-        if (algorithm != null)
-          yield return new KeyValuePair<string, Func<IItem>>(algorithm.GetType().GetPrettyName(), () => ExportAlgorithm(algorithm));
-
-        var problem = algorithm != null ? algorithm.Problem as IDataAnalysisProblem : Source as IDataAnalysisProblem;
-        if (problem != null)
-          yield return new KeyValuePair<string, Func<IItem>>(problem.GetType().GetPrettyName(), () => ExportProblem(problem));
-
-        var problemData = problem != null ? problem.ProblemData : Source as IDataAnalysisProblemData;
-        if (problemData != null)
-          yield return new KeyValuePair<string, Func<IItem>>(problemData.GetType().GetPrettyName(), () => ExportProblemData(problemData));
-
-        // ToDo: Export CSV
-      }
-    }
-    public bool CanExport {
-      get { return Source is IAlgorithm || Source is IDataAnalysisProblem || Source is IDataAnalysisProblemData; }
-    }
-
     [Storable]
     public IFilteredPreprocessingData Data { get; private set; }
@@ -62,11 +41,14 @@
     private IItem Source { get; set; }
 
+    public event EventHandler Reset;
 
-    public PreprocessingContext() : this(new RegressionProblemData()) {
-      Name = "Data Preprocessing";
+    #region Constructors
+    public PreprocessingContext()
+      : this(new RegressionProblemData()) {
     }
-    public PreprocessingContext(IItem source)
+    public PreprocessingContext(IDataAnalysisProblemData problemData, IItem source = null)
       : base("Data Preprocessing") {
-      Import(source);
+      if (problemData == null) throw new ArgumentNullException("problemData");
+      Import(problemData, source);
     }
 
@@ -79,19 +61,24 @@
       Data = cloner.Clone(original.Data);
     }
-
     public override IDeepCloneable Clone(Cloner cloner) {
       return new PreprocessingContext(this, cloner);
     }
+    #endregion
 
     #region Import
-    public void Import(IItem source) {
-      Source = source;
-      var namedSource = source as INamedItem;
-      if (namedSource != null) Name = "Preprocessing: " + namedSource.Name;
-
-      var dataSource = ExtractProblemData(source);
-      Data = new FilteredPreprocessingData(new TransactionalPreprocessingData(dataSource));
+    public void Import(IDataAnalysisProblemData problemData, IItem source = null) {
+      if (problemData == null) throw new ArgumentNullException("problemData");
+      if (source != null && ExtractProblemData(source) != problemData)
+        throw new ArgumentException("The ProblemData extracted from the Source is different than the given ProblemData.");
+      Source = source ?? problemData;
+      var namedSource = Source as INamedItem;
+      if (namedSource != null)
+        Name = "Preprocessing " + namedSource.Name;
+      Data = new FilteredPreprocessingData(new TransactionalPreprocessingData(problemData));
+      OnReset();
+      // Reset GUI:
+      // - OnContentChanged for PreprocessingView!
+      // event? task(async import)?
     }
-
     private IDataAnalysisProblemData ExtractProblemData(IItem source) {
       var algorithm = source as Algorithm;
@@ -103,13 +90,27 @@
 
     #region Export
-    public IItem Export() {
-      if (Source is IAlgorithm)
-        return ExportAlgorithm((IAlgorithm)Source);
-      if (Source is IDataAnalysisProblem)
-        return ExportProblem((IDataAnalysisProblem)Source);
-      if (Source is IDataAnalysisProblemData)
-        return ExportProblemData((IDataAnalysisProblemData)Source);
-      return null;
+    public bool CanExport {
+      get { return Source is IAlgorithm || Source is IDataAnalysisProblem || Source is IDataAnalysisProblemData; }
     }
+    public IEnumerable<KeyValuePair<string, Func<IItem>>> GetSourceExportOptions() {
+      var algorithm = Source as IAlgorithm;
+      if (algorithm != null)
+        yield return new KeyValuePair<string, Func<IItem>>(
+          algorithm.GetType().GetPrettyName(),
+          () => ExportAlgorithm(algorithm));
+
+      var problem = algorithm != null ? algorithm.Problem as IDataAnalysisProblem : Source as IDataAnalysisProblem;
+      if (problem != null)
+        yield return new KeyValuePair<string, Func<IItem>>(
+          problem.GetType().GetPrettyName(),
+          () => ExportProblem(problem));
+
+      var problemData = problem != null ? problem.ProblemData : Source as IDataAnalysisProblemData;
+      if (problemData != null)
+        yield return new KeyValuePair<string, Func<IItem>>(
+          problemData.GetType().GetPrettyName(),
+          () => ExportProblemData(problemData));
+    }
+
     private IAlgorithm ExportAlgorithm(IAlgorithm source) {
       var preprocessedAlgorithm = (IAlgorithm)source.Clone();
@@ -117,24 +118,29 @@
       preprocessedAlgorithm.Runs.Clear();
       var problem = (IDataAnalysisProblem)preprocessedAlgorithm.Problem;
-      SetNewProblemData(problem);
+      problem.ProblemDataParameter.ActualValue = CreateNewProblemData();
       return preprocessedAlgorithm;
     }
     private IDataAnalysisProblem ExportProblem(IDataAnalysisProblem source) {
       var preprocessedProblem = (IDataAnalysisProblem)source.Clone();
-      SetNewProblemData(preprocessedProblem);
+      preprocessedProblem.ProblemDataParameter.ActualValue = CreateNewProblemData();
       return preprocessedProblem;
     }
     private IDataAnalysisProblemData ExportProblemData(IDataAnalysisProblemData source) {
+      return CreateNewProblemData();
+    }
+
+    public IDataAnalysisProblemData CreateNewProblemData() {
       var creator = new ProblemDataCreator(this);
-      var preprocessedProblemData = creator.CreateProblemData(source);
-      preprocessedProblemData.Name = "Preprocessed " + source.Name;
-      return preprocessedProblemData;
-    }
-    private void SetNewProblemData(IDataAnalysisProblem problem) {
-      var data = ExtractProblemData(problem.ProblemData);
-      problem.ProblemDataParameter.ActualValue = data;
-      problem.Name = "Preprocessed " + problem.Name;
+      var oldProblemData = ExtractProblemData(Source);
+      var newProblemData = creator.CreateProblemData(oldProblemData);
+      newProblemData.Name = "Preprocessed " + oldProblemData.Name;
+      return newProblemData;
     }
     #endregion
+
+    protected virtual void OnReset() {
+      if (Reset != null)
+        Reset(this, EventArgs.Empty);
+    }
   }
 }
Index: /trunk/sources/HeuristicLab.DataPreprocessing/3.4/ProblemDataCreator.cs
===================================================================
--- /trunk/sources/HeuristicLab.DataPreprocessing/3.4/ProblemDataCreator.cs	(revision 13507)
+++ /trunk/sources/HeuristicLab.DataPreprocessing/3.4/ProblemDataCreator.cs	(revision 13508)
@@ -48,5 +48,7 @@
       IDataAnalysisProblemData problemData;
 
-      if (oldProblemData is RegressionProblemData) {
+      if (oldProblemData is TimeSeriesPrognosisProblemData) {
+        problemData = CreateTimeSeriesPrognosisData((TimeSeriesPrognosisProblemData)oldProblemData);
+      } else if (oldProblemData is RegressionProblemData) {
         problemData = CreateRegressionData((RegressionProblemData)oldProblemData);
       } else if (oldProblemData is ClassificationProblemData) {
@@ -69,4 +71,16 @@
     }
 
+    private IDataAnalysisProblemData CreateTimeSeriesPrognosisData(TimeSeriesPrognosisProblemData oldProblemData) {
+      var targetVariable = oldProblemData.TargetVariable;
+      if (!context.Data.VariableNames.Contains(targetVariable))
+        targetVariable = context.Data.VariableNames.First();
+      var inputVariables = GetDoubleInputVariables(targetVariable);
+      var newProblemData = new TimeSeriesPrognosisProblemData(ExportedDataset, inputVariables, targetVariable, Transformations) {
+        TrainingHorizon = oldProblemData.TrainingHorizon,
+        TestHorizon = oldProblemData.TestHorizon
+      };
+      return newProblemData;
+    }
+
     private IDataAnalysisProblemData CreateRegressionData(RegressionProblemData oldProblemData) {
       var targetVariable = oldProblemData.TargetVariable;
@@ -83,6 +97,7 @@
         targetVariable = context.Data.VariableNames.First();
       var inputVariables = GetDoubleInputVariables(targetVariable);
-      var newProblemData = new ClassificationProblemData(ExportedDataset, inputVariables, targetVariable, Transformations);
-      newProblemData.PositiveClass = oldProblemData.PositiveClass;
+      var newProblemData = new ClassificationProblemData(ExportedDataset, inputVariables, targetVariable, Transformations) {
+        PositiveClass = oldProblemData.PositiveClass
+      };
       return newProblemData;
     }
